# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class DescribeAlarmsRequest(JDCloudRequest):
    """
    查询规则, 查询参数组合及优先级从高到低为：
1：alarmIds不为空
2：alarmId不为空
3：serviceCode不为空
3.1：serviceCode + resourceId
3.2: serviceCode + resourceIds
3.3: serviceCode + ruleName
4：serviceCodes不为空
4.1：serviceCode + resourceId
4.2: serviceCode + resourceIds
4.3: serviceCode + ruleName
5: 所有规则
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(DescribeAlarmsRequest, self).__init__(
            '/regions/{regionId}/alarms', 'GET', header, version)
        self.parameters = parameters


class DescribeAlarmsParameters(object):

    def __init__(self, regionId, ):
        """
        :param regionId: 地域 Id
        """

        self.regionId = regionId
        self.pageNumber = None
        self.pageSize = None
        self.serviceCode = None
        self.groupCode = None
        self.resourceId = None
        self.ruleType = None
        self.status = None
        self.enabled = None
        self.isAlarming = None
        self.alarmId = None
        self.filters = None

    def setPageNumber(self, pageNumber):
        """
        :param pageNumber: (Optional) 当前所在页，默认为1
        """
        self.pageNumber = pageNumber

    def setPageSize(self, pageSize):
        """
        :param pageSize: (Optional) 页面大小，默认为20；取值范围[1, 100]
        """
        self.pageSize = pageSize

    def setServiceCode(self, serviceCode):
        """
        :param serviceCode: (Optional) 产品线标识,默认返回该serviceCode下所有group的数据。eg:serviceCode=jdw（jdw产品线下包含jdw-master与jdw-segment两个分组)会返回jdw-master和jdw-segment的数据。
        """
        self.serviceCode = serviceCode

    def setGroupCode(self, groupCode):
        """
        :param groupCode: (Optional) 分组标识、指定该参数时，查询只返回该group的数据。groupCode参数仅在与serviceCode匹配时生效；eg:serviceCode=jdw、groupCode=jdw-master,只返回jdw-master分组的数据，不返回jdw-segment的数据。
        """
        self.groupCode = groupCode

    def setResourceId(self, resourceId):
        """
        :param resourceId: (Optional) 资源ID,根据resourceId查询时必须指定serviceCode才会生效
        """
        self.resourceId = resourceId

    def setRuleType(self, ruleType):
        """
        :param ruleType: (Optional) 规则类型, 1表示资源监控，6表示站点监控,7表示可用性监控
        """
        self.ruleType = ruleType

    def setStatus(self, status):
        """
        :param status: (Optional) 规则报警状态, 1：正常, 2：报警，4：数据不足
        """
        self.status = status

    def setEnabled(self, enabled):
        """
        :param enabled: (Optional) 规则状态：1为启用，0为禁用
        """
        self.enabled = enabled

    def setIsAlarming(self, isAlarming):
        """
        :param isAlarming: (Optional) 是否为正在报警的规则，0为忽略，1为是，与 status 同时只能生效一个,isAlarming 优先生效
        """
        self.isAlarming = isAlarming

    def setAlarmId(self, alarmId):
        """
        :param alarmId: (Optional) 规则的id，若指定filter的alarmIds过滤时，忽略该参数
        """
        self.alarmId = alarmId

    def setFilters(self, filters):
        """
        :param filters: (Optional) 服务码或资源Id列表
serviceCodes - 产品线servicecode，精确匹配，支持多个
resourceIds - 资源Id，精确匹配，支持多个（必须指定serviceCode才会在该serviceCode下根据resourceIds过滤，否则该参数不生效）
alarmIds - 规则id，精确匹配，支持多个
ruleName - 规则名称，模糊匹配，支持单个
        """
        self.filters = filters

